gap2lo = 10
gap2hi = 11
j2lo   = 12
j2hi   = 13
l2lo   = 14
l2hi   = 15

shellsort sty sz2hi+1
          stx sz2lo+1
          ldy addrhi
          sty lss10+1
          sty datahi2+1
          ldy addrlo
          sty datalo1+1
          sty datalo2+1
          tax
lss1      stx lssm+1
          bne lss10
          rts

lss10     lda #0
          sta j2hi
datalo1   lda #0
          sta j2lo
          lda gap2table-2,x
          sta gap2lo
          clc
          adc j2lo   ;#<data
          sta l2lo
          lda gap2table-1,x
          sta gap2hi
          adc j2hi   ;#>data
          sta l2hi
lss3      ;lda l2hi
sz2hi     cmp #0
          bcc lss2
          bne lssm

          lda l2lo
sz2lo     cmp #0
          bcc lss2

lssm      ldx #0
          dex
          dex
          bpl lss1   ;=jmp

lss2      lda j2hi
          sta lssm1+1
          lda j2lo
          sta lss5+1
lss8      ldy #2
          lda (l2lo),y
          cmp (j2lo),y
          dey
          lda (l2lo),y
          sbc (j2lo),y
          dey
          lda (l2lo),y
          sbc (j2lo),y
          bcs lss5

lss6      ldy #7
cploop    lda (j2lo),y
          tax
          lda (l2lo),y
          sta (j2lo),y
          txa
          sta (l2lo),y
          dey
          bpl cploop

          sec
          lda j2lo
          sta l2lo
          sbc gap2lo
          sta j2lo
          lda j2hi
          sta l2hi
          sbc gap2hi
          bcc lss5

          sta j2hi
          lda j2lo
datalo2   cmp #<data
          lda j2hi
datahi2   sbc #>data
          bcs lss8

lss5      lda #0
          clc
          adc #ESZ
          sta j2lo
lssm1     lda #0
          adc #0
          sta j2hi

          lda j2lo
          adc gap2lo
          sta l2lo
          lda j2hi
          adc gap2hi
          sta l2hi
          jmp lss3

gap2table .word 1*ESZ, 4*ESZ, 10*ESZ, 23*ESZ, 57*ESZ, 132*ESZ, 301*ESZ, 701*ESZ, 1750*ESZ, 4759*ESZ, 12923*ESZ, 35129*ESZ
